from p2_store.postgresInt import SQLit

class Experiment:

    def __init__(self):
        self.sqlit = SQLit()

    def deleteExperiment(self, filename):    
        QUERY = "DELETE FROM experiments WHERE filename=%s;"
        return self.sqlit.execute(QUERY, (filename,))

    def getExperiments(self):
        QUERY = "SELECT filename FROM experiments ORDER BY filename ASC;"
        return (self.sqlit.execute(QUERY))
        
    def getExperiment(self, filename):
        QUERY = "SELECT data FROM experiments WHERE filename = %s;"
        return (self.sqlit.execute(QUERY, (filename,))[0][0])

    def postExperiment(self, filename, data):    
        QUERY = "INSERT INTO experiments (filename, data) VALUES (%s, %s);"
        return self.sqlit.execute(QUERY, filename, data)
        
    def updateExperiment(self, filename, data):    
        QUERY = "UPDATE experiments SET data=%s WHERE filename=%s;"
        return self.sqlit.execute(QUERY, data, filename)
