from p2_store.postgresInt import SQLit

class Session:

    def __init__(self):
        self.sqlit = SQLit()

    def create_session( self, session ):
        stmt = self.sqlit.insert_stmt('exp_session', session)
        return self.sqlit.execute(stmt, session)


    def get_sessions_paged( self, size=10, offset=0 ):
        """ 
        retrieves a max size of sessions starting from offset or start if none is passed
        if offset is 0 then retrieves the total number of rows as well
        """
        count = size

        if not offset:
            sql = "SELECT count(*) from exp_session;"
            recs = self.sqlit.execute(sql)
            count = recs[0][0]

        cmd = """
            SELECT * FROM exp_session 
                ORDER BY start_time DESC
                LIMIT %s
                OFFSET %s
            """
        return {
                "count": count,
                "records": self.sqlit.execute(cmd, size, offset)
        }


    def get_sessions(self, filter):
        """given a filter as dict, retrieves all sessions that match it"""
        return self.sqlit.select('exp_session', filter)

    def get_sessions_as_dict(self, filter):
        """given a filter as dict, retrieves all sessions that match it"""
        return self.sqlit.select_as_dict('exp_session', filter)

    def update_session(self, exp_id, attrs):
        return self.sqlit.update('exp_session', 'exp_id', exp_id, attrs)

